% Soe San Win
% Boundary Cell
% 25-June-2009

% This function will simulate the boundary cell in the systolic array 
% structure. It will store the diagonal of lower triangular correlation 
% matrix (Phi_half) and compute the angle between the input samples and the
% diagonal of the lower triangular correlation matrix. 

% Inputs: Sample (u) and corresponding parameter: Lower Triangular 
% Correlation Matrix element (Phi_half), and Exponential Weight (lambda) 
% and Gamma (gamma). 
% Outputs: Cosine (c) and Sine (s) of the angle between the input samples 
% and the lower triangular correlation matrix, and computed Gamma (g_out)

function[c s hyp] = boundary(g,f)
    r = sqrt(abs(f)^2+abs(g)^2);
    if ((f ~= 0) && (g == 0))
        c = 1;
        s = 0;
        hyp = f;
    else
        c = abs(f)/r;
        s = g'/r;
        hyp = r;
    end
end 
